package com.ekexiu.project.msconsole.department;

import com.ekexiu.project.msconsole.system.vo.SessionUser;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */
@Path("/department")
public class DepartmentService {

    @Autowrie
    private DepartmentDao departmentDao;

    public DepartmentDao getDepartmentDao() {
        return departmentDao;
    }

    public void setDepartmentDao(DepartmentDao departmentDao) {
        this.departmentDao = departmentDao;
    }

    @Path
    @Post
    public String insert(@JdbcConn(true) Connection con, @LoginUser SessionUser sessionUser, Department department) throws SQLException {
        String id = StringUtil.buildUUID();
        department.setId(id);
        department.setActive(true);
        department.setHospital(sessionUser.getId());
        department.setCreator(sessionUser.getId());
        department.setModifier(sessionUser.getId());
        departmentDao.insert(con, department);
        return id;
    }

    @Path("/update")
    @Post
    public void update(@JdbcConn(true) Connection con, @LoginUser SessionUser sessionUser, Department department) throws SQLException {
        department.setModifier(sessionUser.getId());
        departmentDao.update(con, department);
    }

    @Path("/qo")
    @Get
    public Department query(@JdbcConn Connection con, String id) throws SQLException {
        return departmentDao.query(con, id);
    }

    @Path("/ban")
    @Get
    public void ban(@JdbcConn(true) Connection con, String id, @LoginUser SessionUser sessionUser) throws SQLException {
        departmentDao.ban(con, id, sessionUser.getId());
    }

    @Path("/pq")
    @Get
    public PageQueryResult<Department> pageQuery(@JdbcConn Connection con,@LoginUser SessionUser user, @Nullable Boolean active, @Nullable String name, int pageSize, int pageNo) throws SQLException {
        return departmentDao.pageQuery(con,user.getId(), active, name == null ? null : "%" + name + "%", pageSize, pageNo);
    }

    @Path("/checkName")
    @Get
    public Department queryByName(@JdbcConn Connection con,@LoginUser SessionUser user, String name)throws SQLException {
        return departmentDao.queryByName(con, user.getId(), name);
    }

}
