package com.ekexiu.project.msconsole.doctor;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.annotation.dao.param.SqlColumn;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */
@DAO
public interface DoctorDao {

    @Insert
    int insert(Connection con, Doctor doctor) throws SQLException;

    @Update
    @Exclude({"active", "passwd"})
    int update(Connection con, Doctor doctor) throws SQLException;

    @UpdateWith
    @From(Doctor.class)
    @Where("ACTIVE ='1'")
    @SetSentence("ACTIVE ='0'")
    int ban(Connection con, String id, @Set String modifier) throws SQLException;

    @SelectOne
    @Nullable
    Doctor query(Connection con, String id) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<Doctor> pageQuery(Connection con, String hospital, @Nullable boolean active, @Nullable @Like String name, @Nullable @SqlColumn(handlerClass = StringHandler.class, value = "ID IN (SELECT ID FROM DEPARTMENT WHERE NAME LIKE ?)") String department, int pageSize, int pageNo) throws SQLException;

    @Nullable
    @SelectOne
    Doctor queryByAccount(Connection con, String account) throws SQLException;
}
