package com.ekexiu.project.msconsole.doctor;


import com.ekexiu.project.msconsole.system.vo.SessionUser;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */


@Path("/doctor")
public class DoctorService {

    @Autowrie
    private DoctorDao doctorDao;

    public DoctorDao getDoctorDao() {
        return doctorDao;
    }

    public void setDoctorDao(DoctorDao doctorDao) {
        this.doctorDao = doctorDao;
    }

    @Post
    @Path
    public String insert(@JdbcConn(true)Connection con, @LoginUser SessionUser user,Doctor doctor)throws SQLException {
        String id = StringUtil.buildUUID();
        doctor.setId(id);
        doctor.setActive(true);
        doctor.setCreator(user.getId());
        doctor.setModifier(user.getId());
        doctor.setHospital(user.getId());
        doctorDao.insert(con, doctor);
        return id;
    }

    @Post
    @Path("/update")
    public void update(@JdbcConn(true)Connection con,@LoginUser SessionUser user,Doctor doctor)throws SQLException {
        doctor.setModifier(user.getId());
        doctorDao.update(con, doctor);
    }

    @Get
    @Path("/qo")
    public Doctor query(@JdbcConn Connection con,String id)throws SQLException {
        return doctorDao.query(con, id);
    }

    @Get
    @Path("/pq")
    public PageQueryResult<Doctor> pageQuery(@JdbcConn Connection con, String hospital, @Nullable Boolean active,@Nullable String name,@Nullable String department,int pageSize,int pageNo)throws SQLException {
        return doctorDao.pageQuery(con, hospital, active, name == null ? null : "%" + name + "%", department == null ? null : "%" + department + "%", pageSize, pageNo);
    }

    @Get
    @Path("/ban")
    public void ban(@JdbcConn(true)Connection con,@LoginUser SessionUser user, String id)throws SQLException {
        doctorDao.ban(con, id, user.getId());
    }

    @Get
    @Path("/check")
    public Doctor queryByAccount(@JdbcConn Connection con,String account)throws SQLException {
        return doctorDao.queryByAccount(con, account);
    }
}
