package com.ekexiu.project.msconsole.instrument;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */
@DAO
public interface InstrumentDao {

    @Insert
    int insert(Connection con, Instrument instrument) throws SQLException;

    @Update
    @Exclude({"active"})
    int update(Connection con, Instrument instrument) throws SQLException;

    @UpdateWith
    @From(Instrument.class)
    @Where("ACTIVE ='1'")
    @SetSentence("ACTIVE ='0'")
    int ban(Connection con, String id, @Set String modifier) throws SQLException;

    @Nullable
    @SelectOne
    Instrument query(Connection con, String id) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<Instrument> pageQuery(Connection con, String hospital, @Nullable Boolean active, @Nullable @Like String name, @Nullable String status, int pageSize, int pageNo) throws SQLException;
}
