package com.ekexiu.project.msconsole.instrument;

import com.ekexiu.project.msconsole.system.vo.SessionUser;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */
@Path("/instrument")
public class InstrumentService {

    @Autowrie
    private InstrumentDao instrumentDao;

    public InstrumentDao getInstrumentDao() {
        return instrumentDao;
    }

    public void setInstrumentDao(InstrumentDao instrumentDao) {
        this.instrumentDao = instrumentDao;
    }

    @Path
    @Post
    public String insert(@JdbcConn(true) Connection con, @LoginUser SessionUser sessionUser, Instrument instrument) throws SQLException {
        String id = StringUtil.buildUUID();
        instrument.setId(id);
        instrument.setActive(true);
        instrument.setHospital(sessionUser.getId());
        instrument.setCreator(sessionUser.getId());
        instrument.setModifier(sessionUser.getId());
        instrumentDao.insert(con, instrument);
        return id;
    }

    @Path("/update")
    @Post
    public void update(@JdbcConn(true) Connection con, @LoginUser SessionUser sessionUser, Instrument instrument) throws SQLException {
        instrument.setModifier(sessionUser.getId());
        instrumentDao.update(con, instrument);
    }

    @Path("/qo")
    @Get
    public Instrument query(@JdbcConn Connection con, String id) throws SQLException {
        return instrumentDao.query(con, id);
    }

    @Path("/ban")
    @Get
    public void ban(@JdbcConn(true) Connection con, String id, @LoginUser SessionUser sessionUser) throws SQLException {
        instrumentDao.ban(con, id, sessionUser.getId());
    }

    @Path("/pq")
    @Get
    public PageQueryResult<Instrument> pageQuery(@JdbcConn Connection con, @LoginUser SessionUser user, @Nullable Boolean active, @Nullable String name, @Nullable String status, int pageSize, int pageNo) throws SQLException {
        return instrumentDao.pageQuery(con, user.getId(), active, name == null ? null : "%" + name + "%", status, pageSize, pageNo);
    }

}