package com.ekexiu.project.msconsole.system.dao;

import com.ekexiu.project.msconsole.system.po.Hospital;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.annotation.dao.param.UnEquals;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2019/5/30.
 */
@DAO
public interface HospitalDao {

    @Insert
    int insert(Connection con, Hospital hospital) throws SQLException;

    @Nullable
    @SelectOne
    Hospital query(Connection con, String id) throws SQLException;

    @Update
    @Exclude({"passwd", "active", "account"})
    int update(Connection con, Hospital hospital) throws SQLException;

    @Nullable
    @SelectOne
    Hospital login(Connection con, String account, String passwd) throws SQLException;

    @Nullable
    @SelectOne
    Hospital queryByAccount(Connection con, String account, @Nullable @UnEquals String id) throws SQLException;

    @UpdateWith
    @From(Hospital.class)
    @Where("ACTIVE ='1'")
    @SetSentence("ACTIVE ='0'")
    int ban(Connection con, String id, @Set String modifier) throws SQLException;

    @UpdateWith
    @From(Hospital.class)
    int changePw(Connection con, @Set String passwd, String id) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<Hospital> pageQuery(Connection con, @Nullable Boolean active, @Nullable String level, @Nullable String subLevel, @Nullable String type, @Nullable @Like String name, int pageSize,
                                        int pageNo) throws SQLException;
}
